Subject: RE: [MMUSIC] Re: Multiple 'm' lines with the same port number

From: "Kevin Boyle" <[email-masked]>
Date: Thu, 11 Dec 2003 19:08:51 -0500

All,

Looking back at this email stream, one question remains outstanding in my
mind:

What if the two m= lines have the SAME media type?  For instance:

m=audio 49232 RTP/AVP 18
m=image 49233 UDPTL t38
m=audio 49232 RTP/AVP 100
a=rtpmap:100 PCMU/8000
a=gpmd:100 vbd=yes

For some of the SDP-based protocols, the order of appearance is vital
because it announces preference.  So, this shows preference for T.38 fax
relay over PCMU VBD for fax, while utilizing G.729 for voice.  As far as I
can tell, this construct is allowed, since both m lines using the same port
number use a media type of audio.

Is my understanding correct?

Thanks,

Kevin

-----Original Message-----
From: Stephen Casner [mailto:[email-masked]] 
Sent: Friday, April 25, 2003 2:57 PM
To: Rajesh Kumar
Cc: Colin Perkins; [email-masked]; flemming Andreasen; [email-masked];
[email-masked]; [email-masked]; [email-masked]
Subject: [MMUSIC] Re: Multiple 'm' lines with the same port number

Rajesh,

> Is the use of multiple 'm=' lines with the same port number within an 
> SDP descriptor permitted?

Presuming that the multiple m= lines are all RTP/AVP, then doing so causes
all of the payload formats listed on the m= lines to become part of a single
RTP session (unless they are distinguished by some other aspect of
addressing).  Section 5.2 of the RTP spec addresses NOT multiplexing
different media in the same RTP session.

> In SDP, as it is defined, all the media formats on an 'm=' line are of 
> the same media type (e.g. audio, image, text etc.).
>
> Now consider the case in which two RTP media formats can use a 
> destination port but are registered under different MIME types. For 
> example, text/t140 and audio/PCMU. In this case, there is no recourse 
> except to use multiple media lines with the same port number. For example:

The "can use a destination port" is the tricky part.  We may not agree.

> m=audio 49232 RTP/AVP 0
> m=text 49232 RTP/AVP 100
> a=rtpmap:100 t140
>
> My thought is that although this is unsual, it is not proscribed by 
> SDP syntax in RFC 2327 or in its latest internet draft.

I believe this is proscribed by section 5.2 of the RTP spec because these
two media should not be multiplexed in one RTP session.

My bet is that the real example you are thinking about is fax or modem over
IP.  We've been there before.

                                                        -- Steve

_______________________________________________
mmusic mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/mmusic

_______________________________________________
mmusic mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/mmusic

---

From: Flemming Andreasen <[email-masked]>
Date: Fri, 12 Dec 2003 07:21:18 -0500

Kevin Boyle wrote:

>
>
> All,
>
> Looking back at this email stream, one question remains outstanding in
> my mind:
>
> because it announces preference.

Only for the media formats within a given "m=" line. Multiple "m=" lines
indicates a set of simultaneous media streams; not alternatives.

> So, this shows preference for T.38 fax relay over PCMU VBD for fax,
> while utilizing G.729 for voice.  As far as I can tell, this construct
> is allowed, since both m lines using the same port number use a media
> type of audio.
>

Not quite. Each "m=" line corresponds to a separate media stream. Also,
the consensus of this discussion has been that you are *not* allowed to
use the same port for different media lines, regardless of whether they
share the same top-level MIME type or not.

-- Flemming

> Cc: Colin Perkins; [email-masked]; flemming Andreasen;
> [email-masked]; [email-masked]; [email-masked];
> [email-masked]
>
> Presuming that the multiple m= lines are all RTP/AVP, then doing so
> causes all of the payload formats listed on the m= lines to become
> part of a single RTP session (unless they are distinguished by some
> other aspect of addressing).  Section 5.2 of the RTP spec addresses
> NOT multiplexing different media in the same RTP session.
>
> I believe this is proscribed by section 5.2 of the RTP spec because
> these two media should not be multiplexed in one RTP session.
>
> My bet is that the real example you are thinking about is fax or modem
> over IP.  We've been there before.
>
>                                                         -- Steve
>

---

From: "Paul E. Jones" <[email-masked]>
Date: Sun, 14 Dec 2003 23:27:19 -0500

Flemming,

Perhaps Kevin should have offered slightly different syntax, using FID.
Consider the following syntax:

 a=group:FID 1 2 3
 m=audio 49232 RTP/AVP 18
 a=mid:1
 m=image 49233 UDPTL t38
 a=mid:2
 a=mid:3

Is it still the consensus that, when using this syntax, the port numbers
must be distinct?

Paul

----- Original Message ----- 
From: "Flemming Andreasen" <[email-masked]>
To: "Kevin Boyle" <[email-masked]>
Cc: "Stephen Casner" <[email-masked]>; "Rajesh Kumar" <[email-masked]>;
"Colin Perkins" <[email-masked]>; <[email-masked]>; <[email-masked]>;
<[email-masked]>; <[email-masked]>; <[email-masked]>
Sent: Friday, December 12, 2003 7:21 AM
Subject: Re: [MMUSIC] Re: Multiple 'm' lines with the same port number

---

From: Flemming Andreasen <[email-masked]>
Date: Mon, 15 Dec 2003 09:47:04 -0500

> Is it still the consensus that, when using this syntax, the port numbers

Yes. RFC 3388 is very clear about this point in Section 7.5.3:

    "FID MUST NOT be used to group "m" lines with the
   same IP address/port. "

-- Flemming